spool VAP_Update_2.7.2.log

ALTER SESSION SET CURRENT_SCHEMA = VAP;

SET SQLBLANKLINES OFF

CREATE TABLE VAP.PATIENT_CONFIDENTIALITY (
    PATIENT_CONFIDENTIALITY_ID INT NOT NULL,
    PATIENT_ICN VARCHAR2(255) NOT NULL,
    CONFIDENTIALITY_CODE VARCHAR2(255) NOT NULL,
    STORED_TS DATE,
    CONSTRAINT "PK_PATIENT_CONFIDENTIALITY" PRIMARY KEY(PATIENT_CONFIDENTIALITY_ID),
    CONSTRAINT "UK_PAT_CONF_PATIENT_ICN" UNIQUE(PATIENT_ICN)
)
TABLESPACE "USERS"; 

CREATE OR REPLACE SYNONYM VAP_APP.PATIENT_CONFIDENTIALITY FOR VAP.PATIENT_CONFIDENTIALITY;
GRANT SELECT ON "VAP"."PATIENT_CONFIDENTIALITY" TO VAP_USER;
GRANT SELECT ON "VAP"."PATIENT_CONFIDENTIALITY" TO VAP_READ;
GRANT INSERT ON "VAP"."PATIENT_CONFIDENTIALITY" TO VAP_USER;
GRANT UPDATE ON "VAP"."PATIENT_CONFIDENTIALITY" TO VAP_USER;
GRANT DELETE ON "VAP"."PATIENT_CONFIDENTIALITY" TO VAP_USER;

INSERT INTO CONSENT_TYPE(CONSENT_TYPE_ID, NAME)
VALUES(110,	'Withhold for Treatment Authorization');

INSERT INTO CONSENT_TYPE(CONSENT_TYPE_ID, NAME)
VALUES(111, 'Withhold for Treatment Revocation');

--------------------------------------------------------
--  UPDATE DESCRIPTORS
--  These statements came from VAP-E team as part of Section 508 fixes
--  they made post- VAP 2.7.1. Manually "merged" them into this
--  SQL file for the VAP 2.7.2 release (eHX-E Build 3).
--------------------------------------------------------
UPDATE DESCRIPTOR SET TEXT='Add all organizations to the announcement list' WHERE NAME='batchAnnounceMoveAll';
UPDATE DESCRIPTOR SET TEXT='Add selected organizations to the announcement list' WHERE NAME='batchAnnounceMoveSelectedRight';
UPDATE DESCRIPTOR SET TEXT='Remove selected organizations from the announcement list' WHERE NAME='batchAnnounceMoveSelectedLeft';

COMMIT;
