package gov.va.nvap.server.test.endpoint.pdq;

import gov.va.nvap.common.file.FileUtil;
import gov.va.nvap.common.splitter.Splitter;
import gov.va.nvap.common.splitter.SplitterException;
import gov.va.nvap.common.transformer.Transformer;
import gov.va.nvap.common.transformer.TransformerException;
import gov.va.nvap.server.test.common.AbstractTestCase;

import java.io.IOException;
import java.util.Map;

import javax.annotation.Resource;

import junit.framework.Assert;

import org.junit.Test;

public class TestExtendedViewDataExpressions extends AbstractTestCase {

	@Resource(name = "rpcExtendedResponseSplitter")
	private Splitter<String, Map<String, String>> rpcExtendedResponseSplitter;

	@Resource(name = "rpcResponsesToPropertyMapRecordTwoPass")
	private Transformer<Map<String, String>, Map<String, Map<String, String>>> rpcResponsesToPropertyMapRecordTwoPass;

	@Test
	public void testPatientExtendedViewSplitter() throws IOException,
			TransformerException, SplitterException {
		final org.springframework.core.io.Resource resource = this.applicationContext
				.getResource("classpath:gov/va/nvap/server/test/endpoint/vista/mvi/MPI RETURN CORRELATION DATA.txt");
		final String mpiPExtendedViewData = FileUtil.getResource(resource);
		final Map<String, String> splitResponses = this.rpcExtendedResponseSplitter
				.split(mpiPExtendedViewData);

		final Map<String, Map<String, String>> propertyMap = this.rpcResponsesToPropertyMapRecordTwoPass
				.transform(splitResponses);
		Assert.assertNotNull("Cannot be null!", propertyMap);
	}
}
