package gov.va.nvap.web.dao;

import gov.va.nvap.web.user.role.UserRole;
import java.util.ArrayList;
import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import javax.persistence.TypedQuery;

/**
 *
 * @author Zack Peterson
 */
public class UserRoleDAO {

    @PersistenceContext
    private EntityManager em;

    public void setEntityManager(EntityManager entityManager) {
        this.em = entityManager;
    }

    public List<UserRole> findAll() {
        try {
            final TypedQuery<UserRole> q = this.em.createNamedQuery("UserRole.findAll", UserRole.class);
            return q.getResultList();
        } catch (final NoResultException nre) {
            return new ArrayList<>();
        }
    }

    public List<UserRole> findByUserName(String userName) {
        try {
            final TypedQuery<UserRole> q = this.em.createNamedQuery("UserRole.findByUserName", UserRole.class);
            q.setParameter("userName", userName);
            return q.getResultList();
        } catch (final NoResultException nre) {
            return new ArrayList<>();
        }
    }

    public List<String> findUserRoleNames(String userName) {
        try {
            final TypedQuery<String> q = this.em.createNamedQuery("UserRole.findUserRoleNames", String.class);
            q.setParameter("userName", userName);
            return q.getResultList();
        } catch (final NoResultException nre) {
            return new ArrayList<>();
        }
    }
}
