<%-- 
    Document   : batchAnnounceDetail
    Created on : Nov 21, 2016, 2:59:51 PM
    Author     : Johann Sonnenberg
--%>

<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<script language="JavaScript">
    $(document).ready(function () {
        //initial data table setup and call for the first recordset
        $.fn.dataTable.ext.errMode = 'none';

        VAP.common.setProcessingForDataTable('tblBatchAnnounceDetailReport');
        
        VAP.common.reportTable = $('#tblBatchAnnounceDetailReport').DataTable({
            destroy: true,
            searching: false,
            processing: true,
            serverSide: true,
            dom: 'liptipr',
            columnDefs: [
                {orderable: false, targets: [ 0, 1, 2, 3 ]}
            ],
            ajax: "BatchManagerQuery.do_sec?getDetail=true&batchId=<c:out value="${batchId}" />&orgId=<c:out value="${orgId}" />", 
            language: {
                emptyTable: "No records found",
                loadingRecords: ""
            },
            lengthMenu: [ 10, 25, 50, 100, 250, 500 ],
            pageLength: 25
        });
        
        VAP.common.reportTable.on('draw', function () {
            VAP.common.addAriaToDataTable('tblBatchAnnounceDetailReport', VAP.common.reportTable);
        });
    });
</script>
<div class="row">
    <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
        <p>
            Announcement Date: <fmt:formatDate pattern="MM/dd/yyyy hh:mm:ss a" value="${announcedDate}" />
        </p>
        <p>
            Announced To: <c:out value="${announcedToOrg}" />
        </p>
    </div>
</div>
<div class="row">
    <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12" style="overflow-y: scroll; height: 400px;">
        <table id="tblBatchAnnounceDetailReport" class="table table-striped" width="100%" cellspacing="0" role="presentation">
            <thead>
                <tr role="row">
                    <th role="columnheader" class="text-center">Patient IEN</th>
                    <th role="columnheader" class="text-center">SSN</th>
                    <th role="columnheader" class="text-center">Last Name</th>
                    <th role="columnheader" class="text-center">First Name</th>
                </tr>
            </thead>
        </table>
    </div>
</div>