<%--
    Document   : Disclosure Summary Report
--%>

<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib tagdir="/WEB-INF/tags/date" prefix="date"%>
<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@page import="java.util.*"%>
<%@page import="java.text.SimpleDateFormat"%>

<%    
    Date today = new Date();
    SimpleDateFormat ft = new SimpleDateFormat ("MM/dd/yyyy");
    String maxDate = ft.format(today);

    pageContext.setAttribute("maxDate", maxDate);
%>

<f:mainTemplate headerText="Disclosures Summary Report">
    <script language="JavaScript">
        $(document).ready(function () { 
            $('#source').on('change', function () {
                handleSourceChange();
            });
            
            /*$("#startDate").datepicker({
                maxDate: 0,
                dateFormat: 'mm/dd/yy',
                onClose: function (selectedDate) {
                    $("#endDate").datepicker("option", "minDate", selectedDate);
                    $(this).focus();
                }
            });

            $("#endDate").datepicker({
                maxDate: 0,
                dateFormat: 'mm/dd/yy',
                onClose: function (selectedDate) {
                    $("#startDate").datepicker("option", "maxDate", selectedDate);
                    $(this).focus();
                }
            });*/
        
            $('#startDate').datepicker({
                theme: 'vap',
                inputFormat: 'MM/dd/yyyy',
                outputFormat: 'MM/dd/yyyy',
                gainFocusOnConstruction: false,
                max: '<c:out value="${maxDate}" />',
                onUpdate: function(curValue) {
                    $('#endDate').datepicker('min', curValue);
                }
            });

            $('#endDate').datepicker({
                theme: 'vap',
                inputFormat: 'MM/dd/yyyy',
                outputFormat: 'MM/dd/yyyy',
                gainFocusOnConstruction: false,
                max: '<c:out value="${maxDate}" />',
                min: '<c:out value="${startDateDefault}" />',
                onUpdate: function(curValue) {
                    $('#startDate').datepicker('max', curValue);
                }
            });

            //call table with default values on arrival
            buildTable(true);

            //initial data table setup and call for the first recordset
            VAP.common.reportTable.on('draw', function () {
                VAP.common.addAriaToDataTable('exchangeReportTable', VAP.common.reportTable);
                VAP.common.addAriaToDataTable('directReportTable', VAP.common.reportTable);
                VAP.common.addSrollingToDataTable('exchangeReportTable');
                VAP.common.addSrollingToDataTable('directReportTable');
                
            });

            $('#searchButton').on('click', function () {
                $('#exchangeReportTable .dataTables_empty').html(''); //blank out the empty table message if there is one
                $('#directReportTable .dataTables_empty').html(''); //blank out the empty table message if there is one
                
                var startDate = $('#startDate').val();
                var endDate = $('#endDate').val();
                
                var errorMessage = VAP.common.validateStartAndEndDate(startDate, endDate);
                
                if (errorMessage != '') {
                    //we have an error so show the error, and then don't send the ajax request
                    $('#errorMessage').html(errorMessage);
                    $('#errorMessage').show();

                    return false;
                } else {
                    //no error, let's make the call to populate the report
                    $('#results').show();
                    buildTable(false);
                }
            });
            
            $('#startDate,#endDate').on('change', function () {
                //if either date changes, hide the error message if its not already hidden
                $('#errorMessage').hide();
            });
            
            handleSourceChange();       
        });

        VAP.common.constructUrl = function(methodName){
            var url= 'DisclosureSummaryReport.do_sec' +
                '?' + methodName + '=true' +
                '&source=' + $('#source').val() +
                '&startDate=' + $('#startDate').val() +
                '&endDate=' + $('#endDate').val() +
                '&organization=' + $('#organization').val() +
                '&organizationName=' + $('#orgName').val() +
                '&facility=' + $('#facility').val() +
                '&facilityName=' + $('#facilityName').val() +
                '&patientTypes=' + $('#patientTypes').val();

            if($('#source').val() === 'Exchange') {
                url = url + '&sortBy=' + $('#exchangeReportTable').dataTable().fnSettings().aaSorting[0][0] +
                '&sortOrder=' + $('#exchangeReportTable').dataTable().fnSettings().aaSorting[0][1];
            } else {
                url = url + '&sortBy=' + $('#directReportTable').dataTable().fnSettings().aaSorting[0][0] +
                '&sortOrder=' + $('#directReportTable').dataTable().fnSettings().aaSorting[0][1];
            }

            return url;
        };

        handleSourceChange = function() {
            if ($('#source').val() === 'Exchange') {
                $('#extrafilters').show();
                $("#exchangeReportTable_wrapper").show();
                $("#exchangeReportTable").show();
                $("#directReportTable_wrapper").hide();
                $("#directReportTable").hide();                
            } else {
                $('#extrafilters').hide();
                $("#exchangeReportTable_wrapper").hide();
                $("#exchangeReportTable").hide();
                $("#directReportTable_wrapper").show();
                $("#directReportTable").show();                
            }
            $('#results').hide();
        };
        
        buildTable = function(loadingPage) {
            if (loadingPage) {
                VAP.common.setProcessingForDataTable('exchangeReportTable', 'divReportPanel');

                VAP.common.reportTable = $('#exchangeReportTable').DataTable({
                    deferLoading: 0,
                    destroy: true,
                    ajax: { 
                        url: VAP.common.constructUrl("doSearch"),
                        dataSrc: function(json){
                            $('.dataTables_empty').remove();
                            return json.data;
                        },
                        error: function(o){
                            VAP.common.handleErrorsInDataTable('exchangeReportTable', o, 3, 'divReportPanel');
                        }
                    }, 
                    info: false,
                    paging: false,
                    processing: true,
                    searching: false,
                    serverSide: true,
                    columnDefs: [
                        {className: "text-right", targets: [3]}
                    ],
                    "footerCallback": function ( row, data, start, end, display ) {
                        var api = this.api(), data;

                        // Update footer
                        $( api.column( 0 ).footer() ).html(
                            '<strong>Total:</strong>'
                        );

                        $(api.column(3).footer() ).html(
                            '<strong>' + api.column(3, {page:'current'}).data().sum() + '</strong>'
                        );
                    }
                });
            } else if ($('#source').val() === 'Exchange') {
                VAP.common.setProcessingForDataTable('exchangeReportTable', 'divReportPanel');

                VAP.common.reportTable = $('#exchangeReportTable').DataTable({
                    destroy: true,
                    ajax: { 
                        url: VAP.common.constructUrl("doSearch"),
                        dataSrc: function(json){
                            $('.dataTables_empty').remove();
                            return json.data;
                        },
                        error: function(o){
                            VAP.common.handleErrorsInDataTable('exchangeReportTable', o, 3, 'divReportPanel');
                        }
                    }, 
                    info: false,
                    paging: false,
                    processing: true,
                    searching: false,
                    serverSide: true,
                    columnDefs: [
                        {className: "text-right", targets: [3]}
                    ],
                    initComplete: function(){
                        // Enable THEAD scroll bars
                        $('.dataTables_scrollHead').css('overflow', 'auto');

                        // Sync THEAD scrolling with TBODY
                        $('.dataTables_scrollHead').on('scroll', function () {
                            $('.dataTables_scrollBody').scrollLeft($(this).scrollLeft());
                        });
                    },
                    "footerCallback": function ( row, data, start, end, display ) {
                        var api = this.api(), data;

                        // Update footer
                        $( api.column( 0 ).footer() ).html(
                            '<strong>Total:</strong>'
                        );

                        $(api.column(3).footer() ).html(
                            '<strong>' + api.column(3, {page:'current'}).data().sum() + '</strong>'
                        );
                    }
                });                    
            } else {
                VAP.common.setProcessingForDataTable('directReportTable', 'divReportPanel');

                VAP.common.reportTable = $('#directReportTable').DataTable({
                    destroy: true,
                    ajax: { 
                        url: VAP.common.constructUrl("doSearch"),
                        dataSrc: function(json){
                            $('.dataTables_empty').remove();
                            return json.data;
                        },
                        error: function(o){
                            VAP.common.handleErrorsInDataTable('directReportTable', o, 2, 'divReportPanel');
                        }
                    }, 
                    info: false,
                    paging: false,
                    processing: true,
                    searching: false,
                    serverSide: true,
                    columnDefs: [
                        {className: "text-right", targets: [1]}
                    ],
                    "footerCallback": function ( row, data, start, end, display ) {
                        var api = this.api(), data;

                        // Update footer
                        $(api.column(1).footer() ).html(
                            api.column(1, {page:'current'}).data().sum()
                        );
                    }
                });
            }
        };
    </script>
    
    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <div class="panel-title">
                        <a href="#" title="Close Search Criteria" aria-label="Close Search Criteria" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="disclosureSummaryReportSearchPanel"></i></a> Search Criteria
                    </div>
                </div>    
                <div class="panel-body" id="disclosureSummaryReportSearchPanel">
                    <div id="errorMessage" class="alert alert-warning" style="display: none;" role="alert"></div>
                    <form name="disclosureSummaryReportForm" action="DisclosureSummaryReport.do_sec" method="POST" class="form-horizontal">
                        <input type="hidden" name="orgName" id="orgName" value="<c:out value="${orgName}"/>" />
                        <input type="hidden" name="facilityName" id="facilityName" value="<c:out value="${facilityName}"/>" />

                        <div class="form-group">
                            <label for="source" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Disclosure Source</label>
                            <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                <select data-tooltip="<c:out value="${descriptors['disclosureSourceField']}"/>" id="source" name="source" onchange="handleSourceChange();" class="form-control">
                                    <option value="Exchange" selected>Exchange</option>
                                    <option value="Direct">Direct</option>
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="startDate" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Start Date</label>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3" data-tooltip="<c:out value="${descriptors['startDateEndDateField']}" />">
                                <input type="text" name="startDate" id="startDate" class="form-control" value="<c:out value="${startDateDefault}" />" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="endDate" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">End Date</label>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3" data-tooltip="<c:out value="${descriptors['startDateEndDateField']}" />">
                                <input type="text" name="endDate" id="endDate" class="form-control" value="<c:out value="${endDateDefault}" />" />
                            </div>
                        </div>
                        <div id="extrafilters">
                            <div class="form-group">
                                <label for="facility" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Patient Preferred Facility</label> 
                                <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                    <select data-tooltip="<c:out value="${descriptors['patientPreferredFacilityFilter']}"/>" id="facility" name="facility" class="form-control" onchange="document.getElementById('facilityName').value = this.options[this.selectedIndex].text;">
                                        <option value="">ALL</option>
                                        <c:forEach var="f" items="${facilities}">
                                            <option value="<c:out value="${f.facilityStation}"/>"
                                                <c:choose>
                                                    <c:when test="${f.facilityStation eq defaultUserFacility.facilityStation}">
                                                        selected
                                                    </c:when>
                                                </c:choose>>
                                                <c:choose>
                                                    <c:when test="${f.facilityName != ''}">
                                                        <c:out value="${f.facilityName}"/>
                                                    </c:when>
                                                    <c:otherwise>
                                                        <c:out value="${fn:split(f.facilityDns, '.')[0]}" />
                                                    </c:otherwise>
                                                </c:choose>
                                                (<c:out value="${f.facilityStation}"/>)
                                            </option>
                                        </c:forEach>
                                    </select>
                                </div>
                            </div>
                            <div class="form-group">
                                <label for="organization" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Organization</label> 
                                <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                    <select data-tooltip="<c:out value="${descriptors['disclosuresSummaryReportOrganizationField']}"/>" id="organization" name="organization" class="form-control" onchange = "document.getElementById('orgName').value = this.options[this.selectedIndex].text;">
                                        <option value="external" selected>ALL</option>
                                        <c:forEach var="r" items="${activeOrgs}">
                                            <option value="%<c:out value="${r.orgOid}"/>">
                                                <c:out value="${r.orgName}"/>
                                            </option>
                                        </c:forEach>
                                        <c:forEach var="r" items="${inactiveOrgs}">
                                            <option value="%<c:out value="${r.orgOid}"/>">[INACTIVE] <c:out value="${r.orgName}"/></option>
                                        </c:forEach>
                                    </select>
                                </div>
                            </div>
                            <div class="form-group">
                                <label for="patientTypes" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Patient Types</label>
                                <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                    <select data-tooltip="<c:out value="${descriptors['patientTypesField']}"/>" id="patientTypes" name="patientTypes" class="form-control">
                                        <option value="3">ALL</option>
                                        <option value="1" selected>Real Patients</option>
                                        <option value="2">Test Patients</option>
                                    </select>
                                </div>
                            </div>
                        </div>
                    </form>
                    <div class="form-group">
                        <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6 text-right">
                            <input name="search" title="Search" class="btn btn-primary" type="button" value="Search" id="searchButton"/>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div><div aria-live="assertive" role="alert" id="reportTable_info"></div></div>
    <div id="results">
        <div class="row">
            <div id="divReportContent" class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
                <div class="panel panel-default" id="divReportPanel">
                    <div class="panel-heading">
                        <div class="panel-title">
                            <div class="pull-left">
                                <a href="#" title="Close Search Results" aria-label="Close Search Results" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="disclosureSummaryReportResultsPanel"></i></a> Search Results
                            </div>
                            <div class="pull-right">
                                <a href="#" class="directDownload" data-method="exportToExcel" title="Export to Excel"><i class="fa fa-download" aria-hidden="true"></i> Export to Excel</a>
                            </div>
                            <div class="clearfix"></div>
                        </div>
                    </div>    
                    <div class="panel-body" id="disclosureSummaryReportResultsPanel">
                        <table id="exchangeReportTable" class="table table-striped" width="100%" cellspacing="0" role="presentation">
                            <thead>
                                <tr role="row">
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['disclosureSummaryReportOrganizationColumn']}"/>"><c:out value="${organizationName}"/> Organization</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['disclosureSummaryReportFacilityColumn']}"/>">Patient Preferred Facility</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['disclosureSummaryReportFacilityIDColumn']}"/>">Patient Preferred Facility Station ID</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['disclosureSummaryReportTotalColumn']}"/>" data-tooltip-position="left">Total</span></th>
                                </tr>
                            </thead>
                            <tfoot>
                                <tr role="row">
                                    <%--Filled in by datatables--%>
                                    <td role="gridcell" class="text-left bold"></td>
                                    <td role="gridcell"></td>
                                    <td role="gridcell"></td>
                                    <td role="gridcell" class="text-right bold"></td>
                                </tr>
                            </tfoot>
                        </table>
                        <table id="directReportTable" class="table table-striped" width="100%" cellspacing="0" role="presentation">
                            <thead>
                                <tr role="row">
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['disclosureSummaryReportOrganizationColumn']}"/>">Direct Endpoint</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['disclosureSummaryReportTotalColumn']}"/>" data-tooltip-position="left">Total</span></th>
                                </tr>
                            </thead>
                            <tfoot>
                                <tr role="row">
                                    <%--Filled in by datatables--%>
                                    <td role="gridcell" class="text-left bold">Total:</td>
                                    <td role="gridcell" class="text-right bold"></td>
                                </tr>
                            </tfoot>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</f:mainTemplate>