<%-- 
    Document   : documentSizeReport
    Created on : Feb 22, 2017, 1:09:00 PM
    Author     : Zachary Tubb
--%>

<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@taglib tagdir="/WEB-INF/tags/date" prefix="d" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@page import="java.util.*"%>
<%@page import="java.text.SimpleDateFormat"%>

<%    
    Date today = new Date();
    SimpleDateFormat ft = new SimpleDateFormat ("MM/dd/yyyy");
    String maxDate = ft.format(today);
    
    pageContext.setAttribute("maxDate", maxDate);
%>

<f:mainTemplate headerText="Document Size Report">
    <script language="JavaScript">
        $(document).ready(function () { 
            //initial data table setup and call for the first recordset
            VAP.common.setProcessingForDataTable('tblReport', 'divReportContentPanel');
            
            VAP.common.reportTable = $('#tblReport').DataTable({
                deferLoading: 0,
                destroy: true,
                searching: false,
                processing: true,
                serverSide: true,
                paging: false,
                info: false,
                order: [[0, 'asc']],
                columnDefs: [
                    {className: "text-right", targets: [3,4,5,6]} 
                ],
                "footerCallback": function ( row, data, start, end, display ) {
                    var api = this.api(), data;

                    // Update footer
                    $(api.column(3).footer() ).html(
                        api.column(3, {page:'current'}).data().sum()
                    );
                },
                ajax: { 
                    url: "DocumentSizeReport.do_sec?doSearch=true&startDate=" + $('#startDate').val() + "&endDate=" + $('#endDate').val()
                        + "&organization=" + $('#organization').val() + "&action=" + $('#action').val(),
                    dataSrc: function(json){
                        $('.dataTables_empty').remove();
                        return json.data;
                    },
                    error: function(o){
                        VAP.common.handleErrorsInDataTable('tblReport', o, 3, 'divReportContentPanel');
                    }
                }, 
                lengthMenu: [ 10, 25, 50, 100, 250, 500 ],
                pageLength: 25,
                dom: 'lipt<"pad-bottom-20">ipr'
            });

            VAP.common.reportTable.on('draw', function () {
                VAP.common.addAriaToDataTable('tblReport', VAP.common.reportTable);
            });
            
            /* $("#startDate").datepicker({
                maxDate: 0,
                dateFormat: 'mm/dd/yy',
                onClose: function (selectedDate) {
                    $("#endDate").datepicker("option", "minDate", selectedDate);
                    $(this).focus();
                }
            });

            $("#endDate").datepicker({
                maxDate: 0,
                dateFormat: 'mm/dd/yy',
                onClose: function (selectedDate) {
                    $("#startDate").datepicker("option", "maxDate", selectedDate);
                    $(this).focus();
                }
            }); */
            
            $('#startDate').datepicker({
                theme: 'vap',
                inputFormat: 'MM/dd/yyyy',
                outputFormat: 'MM/dd/yyyy',
                gainFocusOnConstruction: false,
                max: '<c:out value="${maxDate}" />',
                onUpdate: function(curValue) {
                    $('#endDate').datepicker('min', curValue);
                }
            });
            
            $('#endDate').datepicker({
                theme: 'vap',
                inputFormat: 'MM/dd/yyyy',
                outputFormat: 'MM/dd/yyyy',
                gainFocusOnConstruction: false,
                max: '<c:out value="${maxDate}" />',
                min: '<c:out value="${startDateDefault}" />', 
                onUpdate: function(curValue) {
                    $('#startDate').datepicker('max', curValue);
                }
            });
            
            $('#startDate,#endDate').on('change', function () {
                //if either date changes, hide the error message if its not already hidden
                $('#errorMessage').hide();
            });
            
            $('#btnSearch').on('click', function () {
                $('#tblReport .dataTables_empty').html(''); //blank out the empty table message if there is one
                
                var startDate = $('#startDate').val();
                var endDate = $('#endDate').val();
                
                var errorMessage = VAP.common.validateStartAndEndDate(startDate, endDate);
                
                if (errorMessage != '') {
                    //we have an error so show the error, and then don't send the ajax request
                    $('#errorMessage').html(errorMessage);
                    $('#errorMessage').show();

                    return false;
                } else {
                    //no error, let's make the call to populate the report
                    $('#results').show();
                    VAP.common.reportTable.ajax.url("DocumentSizeReport.do_sec?doSearch=true&startDate=" + $('#startDate').val() + "&endDate=" + $('#endDate').val()
                        + "&organization=" + $('#organization').val() + "&action=" + $('#action').val()).load();
                }
            });
            
            VAP.common.constructUrl = function(methodName){
                var url= 'DocumentSizeReport.do_sec' +
                    '?' + methodName + '=true' +
                    '&startDate=' + $('#startDate').val() +
                    '&endDate=' + $('#endDate').val() +
                    '&organization=' + $('#organization').val() +
                    '&organizationName=' + $('#orgName').val() + 
                    '&action=' + $('#action').val();
            
                url = url + '&sortBy=' + $('#tblReport').dataTable().fnSettings().aaSorting[0][0] +
                    '&sortOrder=' + $('#tblReport').dataTable().fnSettings().aaSorting[0][1];
                
                return url;
            };
            
            $('#results').hide();
        });
    </script>
    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <div class="panel-title">
                        <a href="#" title="Close Search Criteria" aria-label="Close Search Criteria" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="documentSizeReportSearchPanel"></i></a> Search Criteria
                    </div>
                </div>    
                <div class="panel-body" id="documentSizeReportSearchPanel">
                    <div id="errorMessage" class="alert alert-warning" style="display: none;" role="alert"></div>
                    <form name="searchForm" id="searchForm" class="form-horizontal">
                        <div class="form-group">
                            <label for="startDate" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Start Date</label>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3" data-tooltip="<c:out value="${descriptors['startDateEndDateField']}" />">
                                <input type="text" name="startDate" id="startDate" class="form-control" value="<c:out value="${startDateDefault}" />" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="endDate" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">End Date</label>
                            <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3" data-tooltip="<c:out value="${descriptors['startDateEndDateField']}" />">
                                <input type="text" name="endDate" id="endDate" class="form-control" value="<c:out value="${endDateDefault}" />" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="organization" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Organization</label> 
                            <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                <input type="hidden" name="orgName" id="orgName" value="<c:out value="${orgName}"/>" />
                                <select data-tooltip="<c:out value="${descriptors['disclosuresSummaryReportOrganizationField']}"/>" id="organization" name="organization" class="form-control" onchange = "document.getElementById('orgName').value = this.options[this.selectedIndex].text;">
                                    <option value="" selected>ALL</option>
                                    <c:forEach var="r" items="${activeOrgs}">
                                        <option value="%<c:out value="${r.orgOid}"/>">
                                            <c:out value="${r.orgName}"/>
                                        </option>
                                    </c:forEach>
                                    <c:forEach var="r" items="${inactiveOrgs}">
                                        <option value="%<c:out value="${r.orgOid}"/>">[INACTIVE] <c:out value="${r.orgName}"/></option>
                                    </c:forEach>
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="action" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Action Type</label>
                            <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                <select id="action" name="action" class="form-control" data-tooltip="<c:out value="${descriptors['actionType']}"/>">
                                    <option value="">ALL</option>
                                    <option value="inbound">Received Documents</option>
                                    <option value="outbound">Disclosed Documents</option>
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6 text-right">
                                <input name="btnSearch" title="Search" class="btn btn-primary" type="button" value="Search" id="btnSearch"/>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
    <div><div aria-live="assertive" role="alert" id="reportTable_info"></div></div>
    <div id="results">
        <div class="row">
            <div id="divReportContent" class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
                <div class="panel panel-default" id="divReportContentPanel">
                    <div class="panel-heading">
                        <div class="panel-title">
                            <div class="pull-left">
                                <a href="#" title="Close Search Results" aria-label="Close Search Results" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="documentSizeReportResultsPanel"></i></a> Search Results
                            </div>
                            <div class="pull-right">
                                <a href="#" class="directDownload" data-method="exportToExcel" title="Export to Excel"><i class="fa fa-download" aria-hidden="true"></i> Export to Excel</a>
                            </div>
                            <div class="clearfix"></div>
                        </div>
                    </div>    
                    <div class="panel-body" id="documentSizeReportResultsPanel">
                        <table id="tblReport" class="table table-striped" width="100%" cellspacing="0" role="presentation">
                            <thead>
                                <tr role="row">
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['documentSizeOrgCol']}"/>"><c:out value="${organizationName}"/> Organization</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['loincCode']}"/>">LOINC Code</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['documentSizeTitle']}"/>">Title</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['documentSizeCount']}"/>">Number of Documents</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['documentSizeAverageSize']}"/>">Average Size (KB)</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['documentSizeMinimumSize']}"/>">Minimum Size (KB)</span></th>
                                    <th role="columnheader" class="text-center"><span data-tooltip="<c:out value="${descriptors['documentSizeMaximumSize']}"/>" data-tooltip-position="left">Maximum Size (KB)</span></th>
                                </tr>
                            </thead>
                            <tfoot>
                                <tr role="row">
                                    <%--Filled in by datatables, total--%>
                                    <td role="gridcell" class="text-left bold">Total:</td>
                                    <td role="gridcell"></td>
                                    <td role="gridcell"></td>
                                    <td role="gridcell" class="text-right bold"></td>
                                    <td role="gridcell"></td>
                                    <td role="gridcell"></td>
                                    <td role="gridcell"></td>
                                </tr>
                            </tfoot>
                        </table>
                        <div aria-live="polite" role="status" id="tblReport_info" class="dataTables_info hidden">Shows monthly received documents summary data</div><%-- because we don't have the "Showing x of x" turned on for this table, we need this here to support aria --%>        
                    </div>
                </div>
            </div>
        </div>
    </div>
</f:mainTemplate>
