<%--
    Document   : editMailDatesForm
    Created on : May 17, 2016, 7:55:35 PM
    Author     : Johann Sonnenberg
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib tagdir="/WEB-INF/tags/date" prefix="date"%>
<jsp:useBean id="now" class="java.util.Date" scope="page" />

<script>
    $(document).ready(function () {
        $(".useDate").datepicker({
            theme: 'vap',
            inputFormat: 'MM/dd/yyyy',
            outputFormat: 'MM/dd/yyyy',
            gainFocusOnConstruction: false
        });

        $("#mailDates").on('click', 'a.removeMailDate', function (event) {
            //remove the div (and contents) around the date that was clicked to be removed
            $(this).closest('.mailDateContainer').remove();

            event.preventDefault();
            return false;
        });

        $('#addAnotherMailDate').on('click', function(event) {
            //get the number of inputs
            var numDates = $(".mailDateContainer").length;

            //append
            var rn = new Date().getTime();
            $('#mailDates').append('<div class="mailDateContainer form-group"><label for="mailDate' + rn +'" id="mailDate' + rn + 'Label" class="control-label col-xs-1 col-sm-1 col-md-1 col-lg-1">Date</label><div class="col-xs-3 col-sm-3 col-md-3 col-lg-3"><div class="input-group"><input type="text" name="mailDate" id="mailDate' + rn + '" class="useDate form-control" value="" aria-labelledby="mailDate'+ rn + 'Label" /><span class="input-group-addon"><a href="#" class="removeMailDate" aria-label="Remove date" title="Remove date"><i class="fa fa-trash-o vap-size-12 black" aria-hidden="true" title="Remove date"></i></a></span></div></div></div>');

            //give it a date picker
            $("#mailDate" + rn).datepicker({
                theme: 'vap',
                inputFormat: 'MM/dd/yyyy',
                outputFormat: 'MM/dd/yyyy',
                gainFocusOnConstruction: false
            });
            
            //give it focus
            $('#mailDate' + rn).focus();
        });

        $("#showLog").on('click', function (event) {
            if ($('#showLog').text() == 'Show log') {
                if (!$('#delayedConsentId').val().length) {
                    var url = '&consentDirId=' + $('#consentDirId').val();
                } else {
                    var url = '&delayedConsentId=' + $('#delayedConsentId').val();
                }

                $.get("PatientDetails.do_sec?getLogEntries=true" + url, function (data) {
                    $("#logResults").html(data);
                });
            }

            $('#logResults').toggle();
            $('#showLog').text($('#showLog').text() == 'Show log' ? 'Hide log' : 'Show log');
        });
    });
</script>

<div class="row">
    <div id="mailDatesErrorMessage" class="alert alert-danger" style="display: none;" role="alert"></div>
    <form name="mailDatesForm" id="mailDatesForm" action="PatientDetails.do_sec?editMailDates=true" method="POST" class="form-horizontal">
        <input type="hidden" name="delayedConsentId" id="delayedConsentId" value="<c:out value="${delayedConsentId}"/>" />
        <input type="hidden" name="consentDirId" id="consentDirId" value="<c:out value="${consentDirId}"/>" />
        <div id="mailDates" class="pad-left-10">
            <c:forEach items="${mailNotifications}" var="md" varStatus="i">
                <div class="mailDateContainer form-group">
                    <label for="mailDate<c:out value="${i.index + 1}" />" class="control-label col-xs-1 col-sm-1 col-md-1 col-lg-1" id="mailDate<c:out value="${i.index + 1}" />Label">Date</label>
                    <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                        <div class="input-group">
                            <input type="text" name="mailDate" id="mailDate<c:out value="${i.index + 1}" />" class="useDate form-control" value="<fmt:formatDate pattern="MM/dd/yyyy" value="${md.sentDate}" />" aria-labelledby="mailDate<c:out value="${i.index + 1}" />Label" />
                            <span class="input-group-addon">
                                <a href="#" class="removeMailDate"><i class="fa fa-trash-o vap-size-12 black" aria-hidden="true" title="Remove date"></i></a>
                            </span>
                        </div>
                    </div>
                </div>
            </c:forEach>
            <c:if test="${fn:length(mailNotifications) == 0}">
                <div class="mailDateContainer form-group">
                    <label for="mailDate1" class="control-label col-xs-1 col-sm-1 col-md-1 col-lg-1" id="mailDate1Label">Date</label>
                    <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3">
                        <div class="input-group">
                            <input type="text" name="mailDate" id="mailDate1" class="useDate form-control" value="<fmt:formatDate pattern="MM/dd/yyyy" value="${now}" />" aria-labelledby="mailDate1Label" />
                            <span class="input-group-addon">
                                <a href="#" class="removeMailDate" aria-label="Remove date" title="Remove date"><i class="fa fa-trash-o vap-size-12 black" aria-hidden="true" title="Remove date"></i></a>
                            </span>
                        </div>
                    </div>
                </div>
            </c:if>
        </div>
        <div id="divAddMailDate" class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <a href="#" id="addAnotherMailDate" class="btn btn-default btn-sm">Add another</a>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <div class="text-right">
                <a href="#" id="showLog" class="btn btn-default btn-sm">Show log</a>
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12 pad-top-10">
            <div id="logResults" style="display: none; overflow-y:scroll; overflow-x:hidden; height:100px; background-color: #DCDDDE; border: 1px #000 solid;"></div>
        </div>
    </form>
</div>