<%--
    Document   : Expiring Consent Notification
    Created By : Nusrath Mohammed
--%>

<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib tagdir="/WEB-INF/tags/date" prefix="date"%>
<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>

<f:mainTemplate headerText="Expiring Consent Notification">
    <script language="JavaScript">
        $(document).ready(function () {
            
        });
    </script>
    <div class="row">
        <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6">
            <c:if test="${not empty message}"> <%-- used for any messaging back from the server. i.e. error logging in or logged out --%> 
                <div class="alert alert-success alert-dismissible pad-bottom-10 pad-top-10 pad-left-10">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <c:out value="${message}" />
                </div>
            </c:if>
            <cpp:errors />
        </div>
    </div>
    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <form name="expiringConsentNotificationForm" action="ExpiringConsentNotification.do_sec" method="POST" class="form-horizontal" data-toggle="validator" role="form"> <%-- onsubmit="return checkDayRange(this)"> --%>
                <div class="form-group">
                    <label for="frequency" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label"><f:requiredField altText="Frequency is a required field." labelText="Frequency" /></label>
                    <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                        <select data-tooltip="<c:out value="${descriptors['expiringConsentNotificationFrequencyField']}"/>" id="frequency" name="frequency" class="form-control" required>
                            <c:choose>
                                <c:when test="${configurationValues.frequency == 'DAILY'}" >
                                    <option value="DAILY" selected>Daily</option>
                                </c:when>
                                <c:otherwise>
                                    <option value="DAILY">Daily</option>
                                </c:otherwise>
                            </c:choose>
                            <c:choose>
                                <c:when test="${configurationValues.frequency == 'WEEKLY'}" >
                                    <option value="WEEKLY" selected>Weekly</option>
                                </c:when>
                                <c:otherwise>
                                    <option value="WEEKLY">Weekly</option>
                                </c:otherwise>
                            </c:choose>
                            <c:choose>
                                <c:when test="${configurationValues.frequency == 'MONTHLY'}" >
                                    <option value="MONTHLY" selected>Monthly</option>
                                </c:when>
                                <c:otherwise>
                                    <option value="MONTHLY">Monthly</option>
                                </c:otherwise>
                            </c:choose>
                        </select>
                    </div>
                </div>
                <div class="form-group">
                    <label for="maxDaysToExpiration" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label"><f:requiredField altText="Days Until Expiration is a required field." labelText="Days Until Expiration" /></label>
                    <div class="col-xs-1 col-sm-1 col-md-1 col-lg-1">
                        <input title="Enter range in days." data-tooltip="<c:out value="${descriptors['expiringConsentNotificationDaysUntilExpirationField']}"/>" id="maxDaysToExpiration" name="maxDaysToExpiration" type="text" maxlength="3" value="<c:out value="${configurationValues.window}"/>" size="3" class="form-control" pattern="^([1-9]|[1-9][0-9]|[1-9][0-9][0-9])$" required />
                    </div>
                </div>
                <div class="form-group">
                    <label for="distributionList" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">
                        <f:requiredField altText="Distribution List is a required field." labelText="Distribution List" /><br />
                        <span style="font-weight: normal;">(one email address per line)</span>
                    </label>
                    <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                        <textarea data-tooltip="<c:out value="${descriptors['expiringConsentNotificationDistributionListField']}"/>" id="distributionList" name="distributionList" rows="8" cols="55" class="form-control" required><c:out value="${configurationValues.emailAddresses}"/></textarea>
                    </div>
                </div>
                <div class="form-group">
                    <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6 text-right">
                        <input name="save" id="save" title="Save" class="btn btn-primary" type="submit" value="Save" />
                    </div>
                </div>
            </form>
        </div>
    </div>
</f:mainTemplate>