<%--
    Document   : optInReport
    Created on : Dec 1, 2014
    Author     : Irakli Kakushadze
--%>
<%@page import="gov.va.nvap.svc.facility.data.Facility"%>
<%@page import="java.util.HashMap"%>
<%@page import="java.util.*"%>
<%@page import="java.text.SimpleDateFormat"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>

<%
    HashMap tips = (HashMap) session.getAttribute("descriptors");
    String facilityFilterTooltip = (String) tips.get("authenticatingFacilityField");
    Facility defaultUserFacility = (Facility) session.getAttribute("defaultUserFacility");
    String defaultUserFacilityName = defaultUserFacility == null ? "" : defaultUserFacility.getFacilityName();
    String defaultUserFacilityStation = defaultUserFacility == null ? "" : defaultUserFacility.getFacilityStation();
    pageContext.setAttribute("facilityFilterTooltip", facilityFilterTooltip);
    pageContext.setAttribute("defaultUserFacility", defaultUserFacility);
    pageContext.setAttribute("defaultUserFacilityName", defaultUserFacilityName);
    pageContext.setAttribute("defaultUserFacilityStation", defaultUserFacilityStation);
    
    Date today = new Date();
    SimpleDateFormat ft = new SimpleDateFormat ("MM/dd/yyyy");
    String maxDate = ft.format(today);
    pageContext.setAttribute("maxDate", maxDate);
%> 

<f:mainTemplate headerText="Opt-In Patients Report">
    <script type="text/javascript">
        $(document).ready(function () {
           
            $('#startDate').datepicker({
                theme: 'vap',
                inputFormat: 'MM/dd/yyyy',
                outputFormat: 'MM/dd/yyyy',
                gainFocusOnConstruction: false,
                max: '<c:out value="${maxDate}" />',
                onUpdate: function(curValue) {
                    $('#endDate').datepicker('min', curValue);
                }
            });

            $('#endDate').datepicker({
                theme: 'vap',
                inputFormat: 'MM/dd/yyyy',
                outputFormat: 'MM/dd/yyyy',
                gainFocusOnConstruction: false,
                max: '<c:out value="${maxDate}" />',
                min: '<c:out value="${startDateDefault}" />',
                onUpdate: function(curValue) {
                    $('#startDate').datepicker('max', curValue);
                }
            });
               
            VAP.common.constructUrl = function (methodName) {
                var url = 'OptInReport.do_sec?' + methodName + '=true' +
                        '&optInReport=true' +
                        '&enteredBy=' + $('#enteredBy').val() +
                        '&patientTypes=' + $('#patientTypes').val() +
                        '&dateType=' + $("input[name='dateType']:checked"). val() +
                        '&startDate=' + $('#startDate').val() +
                        '&endDate=' + $('#endDate').val() +
                        '&stationNumbers=' + facilitiesDialog.getSelectedStationNumbers() +
                        '&consentTypeName=' + $('#consentTypeName').val() +
                        '&includeUnknownVisn=' + facilitiesDialog.getIncludeUnknownVisn() +
                        '&sortBy=' + $('#reportTable').dataTable().fnSettings().aaSorting[0][0] +
                        '&sortOrder=' + $('#reportTable').dataTable().fnSettings().aaSorting[0][1];

                if (methodName === 'exportToCsv' || methodName === 'exportToExcel') {
                    url = url + '&totalRows=' + VAP.common.reportTable.page.info().recordsTotal;
                }

                return url;
            };

            VAP.common.setProcessingForDataTable('reportTable', 'divReportPanel');
            
            VAP.common.reportTable = $('#reportTable').DataTable({
                deferLoading: 0,
                destroy: true,
                ajax: {
                    url: VAP.common.constructUrl("doSearch"),
                    dataSrc: function (json) {
                        $('.dataTables_empty').remove();
                        return json.data;
                    },
                    error: function (o) {
                        VAP.common.handleErrorsInDataTable('reportTable', o, 11, 'divReportPanel');
                    }
                },
                dom: "<'row'<'col-sm-12'l>>" +
                        "<'row'<'col-sm-6'i><'col-sm-6'p>>" +
                        "<'row'<'col-sm-12't<'pad-bottom-20'>r>>" +
                        "<'row'<'col-sm-5'i><'col-sm-7'p>>",
                serverSide: true,
                processing: true,
                searching: false,
                lengthMenu: [10, 25, 50, 100, 250, 500],
                columnDefs: [
                    {
                        targets: 0,
                        data: null,
                        render: function (data, type, full, meta) {
                            return '<a href="#/" onclick="linkToPatient(\'' + data[10] + '\', \'' + data[1] + '\', \'' + data[2] + '\');">' + data[0] + '</a>';
                        }
                    },	
                    {
                        targets: 10,
                        data: null,
                        render: function (data, type, full, meta) {
                            if (data[11] && "true" === data[11]) {
                                return '<a class="btn btn-xs btn-primary" href="#/" onclick="documentView(\'' + data[11] + '\');">View</a>';
                            } else {
                                return "";
                            }
                        }
                    },
                    {className: "vap-col-min-80 dt-head-center", targets: 0},
                    {className: "vap-col-min-200 dt-head-center", targets: [7, 9]},
                    {className: "dt-head-center", targets: [1, 2, 3, 4, 5, 6, 8]},
                    {orderable: false, targets: [10]}
                ],
                pageLength: 25,
                order: [[4, "desc"]]
            });

            VAP.common.reportTable.on('draw', function () {       
                    VAP.common.addAriaToDataTable('reportTable', VAP.common.reportTable);
                    VAP.common.addSrollingToDataTable('reportTable');
            });

            $('#searchButton').on('click', function () {
                    $('#reportTable .dataTables_empty').html(''); //blank out the empty table message if there is one
                    $('#results').show();
                    VAP.common.reportTable.ajax.url(VAP.common.constructUrl('doSearch')).load(); 
            });
            
            $('#results').hide();
        });

        // Used by 'view' link in the last column
        function documentView(documentUniqueId){
            $('#documentUniqueId').val(documentUniqueId);
            document.getElementById('documentViewForm').submit();
        }
    </script>

    <cpp:errors/>

    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12"> 
            <div class="panel panel-default">
                <div class="panel-heading">
                    <div class="panel-title">
                        <a href="#" title="Close Search Criteria" aria-label="Close Search Criteria" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="myReportSearchPanel"></i></a> Search Criteria
                    </div> 
                </div>   
                <div class="panel-body" id="myReportSearchPanel"> 
                    <div class="alert alert-info">
                        Fill in the fields below to narrow your search.
                    </div>
                    <form name="optInReportForm" action="OptInReport.do_sec" method="POST" onsubmit="return doSubmit(this)" class="form-horizontal">
                        <fieldset>
                            <jsp:include page="reporting/common/facilitiesFilter.jsp">
                                <jsp:param name="defaultUserFacility" value="${defaultUserFacility}" />
                                <jsp:param name="defaultUserFacilityName" value="${defaultUserFacilityName}" />
                                <jsp:param name="defaultUserFacilityStation" value="${defaultUserFacilityStation}" />                                                                            
                                <jsp:param name="facilityFilterTooltip" value="${facilityFilterTooltip}" />
                                <jsp:param name="optInReport" value="true" />
                            </jsp:include>
                            <div class="form-group">
                                <label  class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label" for="consentTypeName">Consent Type</label>
                                <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                    <select class="form-control" id="consentTypeName" name="consentTypeName" data-tooltip="<c:out value="${descriptors['consentTypeField']}" />">
                                        <option value="" selected>ALL Authorizations</option>
                                        <option value="NwHIN Authorization"><c:out value="${organizationName}"/> Authorizations</option>
                                        <option value="SSA Authorization">SSA Authorizations</option>
                                    </select>
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label" for="enteredBy">Entered By</label>
                                <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                    <input class="form-control" title="Entered By" id="enteredBy" name="enteredBy" type="text" maxlength="255" data-tooltip="<c:out value="${descriptors['enteredByField']}" />"/>
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label" for="patientTypes">Patient Types</label>
                                <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                    <select class="form-control" id="patientTypes" name="patientTypes" data-tooltip="<c:out value="${descriptors['patientTypesField']}" />">
                                        <option value="3">ALL</option>
                                        <option value="1" selected>Real Patients</option>
                                        <option value="2">Test Patients</option>
                                    </select>
                                </div>
                            </div>
                            <div class="form-group">
                                <fieldset>
                                    <legend class="col-xs-2 col-sm-2 col-md-2 col-lg-2 vap-input-group-legend pad-top-3">Selection Date</legend>
                                    <div class="col-xs-4 col-sm-4 col-md-4 col-lg-4">
                                        <label class="radio-inline">
                                            <input type ="radio" name="dateType" id="dateTypeEntry" value="entryDate" checked />
                                            Entry Date
                                        </label>
                                        <label class="radio-inline">
                                            <input type ="radio" name="dateType" id="dateTypeOptIn" value="optInDate"/>
                                            Opt In Date
                                        </label>
                                    </div>
                                </fieldset>
                            </div>
                            <div class="form-group">
                                <label for="startDate" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">Start Date</label>
                                <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3" data-tooltip="<c:out value="${descriptors['startDateEndDateField']}" />">
                                    <input type="text" name="startDate" id="startDate" class="form-control" placeholder="MM/dd/yyyy" value="<c:out value="${startDateDefault}" />" />
                                </div>
                            </div>
                            <div class="form-group">
                                <label for="endDate" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label">End Date</label>
                                <div class="col-xs-3 col-sm-3 col-md-3 col-lg-3" data-tooltip="<c:out value="${descriptors['startDateEndDateField']}" />">
                                    <input type="text" name="endDate" id="endDate" class="form-control" placeholder="MM/dd/yyyy" value="<c:out value="${endDateDefault}" />" />
                                </div>
                            </div>                                                                                        
                        </fieldset>
                    </form>
                    <div class="form-group">
                        <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6 text-right">
                            <input id="searchButton" name="search" title="Search" class="btn btn-primary" type="submit" value="Search"/>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div><div aria-live="assertive" role="alert" id="reportTable_info"></div></div>
    <div id="results">
        <div class="panel panel-default" id="divReportPanel">
            <div class="panel-heading">
                <div class="panel-title">
                    <div class="pull-left">
                        <a href="#" title="Close Search Results" aria-label="Close Search Results" class="vap-panel-hide-show"><i class="fa fa-minus" aria-hidden="true" data-panel-body="myResultsPanel"></i></a> Search Results
                    </div>
                    <div class="pull-right"><!-- right align the buttons -->
                        <a href="#" data-toggle="modal" data-target="#confirmExportModal" data-method="exportToExcel" title="Export to Excel" class="pad-right-10"><i class="fa fa-download" aria-hidden="true"></i> Export to Excel</a>
                        <a href="#" data-toggle="modal" data-target="#confirmExportModal" data-method="exportToCsv" title="Export to CSV" class="pad-right-10"><i class="fa fa-download" aria-hidden="true"></i> Export to CSV</a>
                    </div>
                    <div class="clearfix"></div>
                </div>
            </div>   
            <div class="panel-body" id="myResultsPanel">
                <%@include file="patientLinkForm.jsp"%>  
                <form action="OptInOptOutReport.do_sec" method="POST" onsubmit="return doSubmit(this)" id="documentViewForm">
                    <input type="hidden" name="view" value="true"> 
                    <input type="hidden" name="documentUniqueId" value="" id="documentUniqueId">
                </form>
                <br/>
                <table id="reportTable" class="table table-striped" width="100%" cellspacing="0" role="presentation">
                    <thead>
                        <tr role="row">
                            <th role="columnheader"><span data-tooltip="<c:out value="${descriptors['ssnColumn']}" />">SSN</span></th>
                            <th role="columnheader"><span data-tooltip="<c:out value="${descriptors['lastNameColumn']}" />">Patient Last Name</span></th>
                            <th role="columnheader"><span data-tooltip="<c:out value="${descriptors['firstNameColumn']}" />">Patient First Name</span></th>
                            <th role="columnheader"><span data-tooltip="<c:out value="${descriptors['middleNameColumn']}" />">Patient Middle Name</span></th>
                            <th role="columnheader"><span data-tooltip="<c:out value="${descriptors['optInPatientsReportEntryDateColumn']}" />">Entry Date</span></th>
                            <th role="columnheader"><span data-tooltip="<c:out value="${descriptors['optInPatientsReportOptInDateColumn']}" />">Opt In Date</span></th>
                            <th role="columnheader"><span data-tooltip="<c:out value="${descriptors['optInPatientsReportExpirationDateColumn']}" />">Expiration Date</span></th>
                            <th role="columnheader"><span data-tooltip="<c:out value="${descriptors['consentTypeColumn']}" />">Consent Type</span></th>
                            <th role="columnheader"><span data-tooltip="<c:out value="${descriptors['enteredByManualOrSystemColumn']}" />">Entered By</span></th>
                            <th role="columnheader"><span data-tooltip="<c:out value="${descriptors['optInPatientsReportAuthenticatingFacilityColumn']}" />" data-tooltip-position="left">Authenticating Facility</span></th>
                            <th role="columnheader"><span data-tooltip="<c:out value="${descriptors['genericViewColumn']}"/>" data-tooltip-position="left">View</span></th>
                        </tr>
                    </thead>
                </table>
            </div>
        </div> 
    </div>
</f:mainTemplate>