<%--
    Document   : Patient Search
    Created By : David Vasquez / Robert Snelling
    Modified By: Asha Amritraj
--%>
<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp" %>

<f:mainTemplate headerText="Patient Search Results">
    <c:choose>
        <c:when test="${!empty patients}">
            <script language="JavaScript">
                $(document).ready(function () {
                    //initial data table setup and call for the first recordset
                    $.fn.dataTable.ext.errMode = 'none';

                    VAP.common.reportTable = $('#tblSearchResults').DataTable({
                        searching: false,
                        processing: true,
                        serverSide: false,
                        order: [[0, 'desc']],
                        columnDefs: [
                            {orderable: false, targets: [0,1,2,3,4,5,6]},
                            {className: "text-center", targets: [6]}
                        ],
                        paging: false,
                        info: false,
                        language: {
                            emptyTable: "No records found"
                        }
                    });

                    VAP.common.setProcessingForDataTable('tblSearchResults');

                    VAP.common.reportTable.on('draw', function () {
                        VAP.common.addAriaToDataTable('tblSearchResults', VAP.common.reportTable);
                    });
                });
            </script>
            <div class="alert alert-info">
                The search for patient returned multiple results. Please select a patient from the results.
            </div>
            <div class="row">
                <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
                    <table id="tblSearchResults" class="table table-striped" width="100%" cellspacing="0" role="presentation">
                        <thead>
                            <tr role="row">
                                <th role="columnheader" class="text-center">Last Name</th>
                                <th role="columnheader" class="text-center">First Name</th>
                                <th role="columnheader" class="text-center">Middle Name</th>
                                <th role="columnheader" class="text-center">SSN</th>
                                <th role="columnheader" class="text-center">Date of Birth</th>
                                <th role="columnheader" class="text-center">Gender</th>
                                <th role="columnheader" class="text-center">Action</th>
                            </tr>
                        </thead>
                        <tbody>
                            <c:forEach var="r" items="${patients}" varStatus="i">
                                <tr role="row">
                                    <td role="gridcell"><c:out value="${r.lastName}"/></td>
                                    <td role="gridcell"><c:out value="${r.firstName}"/></td>
                                    <td role="gridcell"><c:out value="${r.middleInitial}"/></td>
                                    <td role="gridcell"><c:out value="${r.ssn}"/></td>
                                    <td role="gridcell"><fmt:formatDate pattern="MM/dd/yyyy" value="${r.dob}" /></td>
                                    <td role="gridcell"><c:out value="${r.gender}"/></td>
                                    <td role="gridcell"><a href="PatientSearchResults.do_sec?select=true&icn=<c:out value="${r.icn}"/>" class="btn btn-primary btn-xs">View Details</a></td>
                                </tr>
                            </c:forEach>
                        </tbody>
                    </table>
                </div>
            </div>
        </c:when>
        <c:otherwise>
            <div class="alert alert-warning">
                The search for patient returned no results.
            </div>
        </c:otherwise>
    </c:choose>
</f:mainTemplate>